#define _USE_MATH_DEFINES
#include <cmath>
#include <iostream>
#include "file.h"
using namespace std;

#include <Imagine/Graphics.h>
using namespace Imagine;

// Taille de la fenetre
const int TAILLE=500;

// Donne la decimale du nombre d.
int donne_decimale(double& d) {
    int i = (int)floor(d);
    d -= i;
    d *= 10;
    return i;
}

// Affiche les cercles correspondant au chiffre n (n=0 est en fait n=10).
void affiche_chiffre(File& f, int n) {
    if(n==0)
        n=10;
    Cercle c = pop(f);
    double rayon = int(c.r * sqrt((1-cos(2*M_PI/n))*(1-cos(2*M_PI/n)) +
                                  sin(2*M_PI/n)*sin(2*M_PI/n)));
    for(int i=0; i<n; i++) {
        Cercle c2;
        c2.r = (int)(rayon/2*c.r/(c.r+rayon/2));
        c2.x = c.x + (int)((c.r-c2.r)*cos(2*i*M_PI/n));
        c2.y = c.y + (int)((c.r-c2.r)*sin(2*i*M_PI/n));
        if(n==1) { // Cas particulier: un seul cercle
            c2.x = c.x;
            c2.y = c.y;
            c2.r = 95*c.r/100;
        }
        if(c2.r>0) { // Trop petit, on ne trace rien
            push(f, c2);
            Color col(rand()%256, rand()%256, rand()%256);
            fillCircle(c2.x, c2.y, c2.r, col);
        }
    }
}

// Affiche les 30 premieres decimales d'un nombre
void affiche_nombre(double nombre) {
    clearWindow();
    Cercle c = {TAILLE/2, TAILLE/2, TAILLE/2};
    File f;
    f.n=0; // Ne pas oublier d'initialiser !
    push(f, c);

    for(int i=0; i<30; i++) {
        int n = donne_decimale(nombre);
        cout << n << flush;
        affiche_chiffre(f, n);
        click();
    }
    cout << endl;
}

int main() {
    double d=M_PI;
    for(int i=0; i<20; i++) {
        cout << donne_decimale(d);
    }
    cout << endl;

    openWindow(TAILLE, TAILLE);
    affiche_nombre(M_PI);

    double hasard=0;
    double puissance10=1;
    for(int i=0; i<20; i++) {
        hasard += (rand()%10) * puissance10;
        puissance10 /= 10.0;
    }
    affiche_nombre(hasard);

    endGraphics();
    return 0;
}
